#ifndef GEONETWORKING_LAYER_H
#define GEONETWORKING_LAYER_H

#include "Layer.hh"
#include "GeoNetworkingCodec.hh"

namespace LibItsGeoNetworking__TestSystem {
  class GeoNetworkingPort;
  class GeoNetworkingReq;
  class GeoNetworkingInd;
}

class GeoNetworkingLayer : public TLayer<LibItsGeoNetworking__TestSystem::GeoNetworkingPort> {
  Params _params;
  GeoNetworkingCodec _codec;
public:
  GeoNetworkingLayer() : _params(), _codec() {};
  GeoNetworkingLayer(const std::string & p_type, const std::string & param);
  virtual ~GeoNetworkingLayer() {};
  
  void sendMsg(const LibItsGeoNetworking__TestSystem::GeoNetworkingReq&, const Params& param);
  
  virtual void sendData(OCTETSTRING& data, Params& params);
  virtual void receiveData(OCTETSTRING& data, Params& params);
};

#endif
